diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/libsrc/dulfsm.cc dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/libsrc/dulfsm.cc
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/libsrc/dulfsm.cc	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/libsrc/dulfsm.cc	2017-12-18 10:41:57.049202070 +0100
@@ -257,35 +257,35 @@
 static OFCondition
 readPDUHead(PRIVATE_ASSOCIATIONKEY ** association,
             unsigned char *buffer, unsigned long maxlength,
-            DUL_BLOCKOPTIONS block, int timeout,
+            DUL_BLOCKOPTIONS block, OFTimeValue timeout,
             unsigned char *PDUtype, unsigned char *PDUreserved,
             unsigned long *PDULength);
 static OFCondition
 readPDU(PRIVATE_ASSOCIATIONKEY ** association, DUL_BLOCKOPTIONS block,
-        int timeout, unsigned char **buffer,
+        OFTimeValue timeout, unsigned char **buffer,
         unsigned char *pduType, unsigned char *pduReserved,
         unsigned long *pduLength);
 static OFCondition
 readPDUBody(PRIVATE_ASSOCIATIONKEY ** association,
-            DUL_BLOCKOPTIONS block, int timeout,
+            DUL_BLOCKOPTIONS block, OFTimeValue timeout,
             unsigned char *buffer, unsigned long maxLength,
             unsigned char *pduType, unsigned char *pduReserved,
             unsigned long *pduLength);
 static OFCondition
 readPDUHeadTCP(PRIVATE_ASSOCIATIONKEY ** association,
                unsigned char *buffer, unsigned long maxLength,
-               DUL_BLOCKOPTIONS block, int timeout,
+               DUL_BLOCKOPTIONS block, OFTimeValue timeout,
                unsigned char *PDUtype, unsigned char *PDUreserved,
                unsigned long *PDULength);
 static OFCondition
 readPDUBodyTCP(PRIVATE_ASSOCIATIONKEY ** association,
-               DUL_BLOCKOPTIONS block, int timeout,
+               DUL_BLOCKOPTIONS block, OFTimeValue timeout,
                unsigned char *buffer, unsigned long maxLength,
                unsigned char *pduType, unsigned char *pduReserved,
                unsigned long *pduLength);
 static OFCondition
-defragmentTCP(DcmTransportConnection *connection, DUL_BLOCKOPTIONS block, time_t timerStart,
-              int timeout, void *b, unsigned long l, unsigned long *rtnLen);
+defragmentTCP(DcmTransportConnection *connection, DUL_BLOCKOPTIONS block, OFTimeValue timerStart,
+              OFTimeValue timeout, void *b, unsigned long l, unsigned long *rtnLen);
 
 static OFString dump_pdu(const char *type, void *buffer, unsigned long length);
 
@@ -2262,7 +2262,7 @@
     server.sin_port = (unsigned short) htons(port);
 
     // get global connection timeout
-    Sint32 connectTimeout = dcmConnectionTimeout.get();
+    OFTimeValue connectTimeout = dcmConnectionTimeout.get();
 
 #ifdef HAVE_WINSOCK_H
     u_long arg = TRUE;
@@ -3202,7 +3202,7 @@
 
 OFCondition
 PRV_NextPDUType(PRIVATE_ASSOCIATIONKEY ** association, DUL_BLOCKOPTIONS block,
-                int timeout, unsigned char *pduType)
+                OFTimeValue timeout, unsigned char *pduType)
 {
     OFCondition cond = EC_Normal;
 
@@ -3256,7 +3256,7 @@
 
 static OFCondition
 readPDU(PRIVATE_ASSOCIATIONKEY ** association, DUL_BLOCKOPTIONS block,
-        int timeout, unsigned char **buffer,
+        OFTimeValue timeout, unsigned char **buffer,
         unsigned char *pduType, unsigned char *pduReserved,
         unsigned long *pduLength)
 {
@@ -3316,7 +3316,7 @@
 static OFCondition
 readPDUHead(PRIVATE_ASSOCIATIONKEY ** association,
             unsigned char *buffer, unsigned long maxLength,
-            DUL_BLOCKOPTIONS block, int timeout,
+            DUL_BLOCKOPTIONS block, OFTimeValue timeout,
             unsigned char *PDUType, unsigned char *PDUReserved,
             unsigned long *PDULength)
 {
@@ -3384,7 +3384,7 @@
 
 static OFCondition
 readPDUBody(PRIVATE_ASSOCIATIONKEY ** association,
-            DUL_BLOCKOPTIONS block, int timeout,
+            DUL_BLOCKOPTIONS block, OFTimeValue timeout,
             unsigned char *buffer, unsigned long maxLength,
             unsigned char *pduType, unsigned char *pduReserved,
             unsigned long *pduLength)
@@ -3433,7 +3433,7 @@
 static OFCondition
 readPDUHeadTCP(PRIVATE_ASSOCIATIONKEY ** association,
                unsigned char *buffer, unsigned long maxLength,
-               DUL_BLOCKOPTIONS block, int timeout,
+               DUL_BLOCKOPTIONS block, OFTimeValue timeout,
      unsigned char *type, unsigned char *reserved, unsigned long *pduLength)
 {
     unsigned long
@@ -3540,7 +3540,7 @@
 
 static OFCondition
 readPDUBodyTCP(PRIVATE_ASSOCIATIONKEY ** association,
-               DUL_BLOCKOPTIONS block, int timeout,
+               DUL_BLOCKOPTIONS block, OFTimeValue timeout,
                unsigned char *buffer, unsigned long maxLength,
                unsigned char *pduType, unsigned char *pduReserved,
                unsigned long *pduLength)
@@ -3619,8 +3619,8 @@
 
 
 static OFCondition
-defragmentTCP(DcmTransportConnection *connection, DUL_BLOCKOPTIONS block, time_t timerStart,
-              int timeout, void *p, unsigned long l, unsigned long *rtnLen)
+defragmentTCP(DcmTransportConnection *connection, DUL_BLOCKOPTIONS block, OFTimeValue timerStart,
+              OFTimeValue timeout, void *p, unsigned long l, unsigned long *rtnLen)
 {
     unsigned char *b;
     int bytesRead;
@@ -3662,7 +3662,7 @@
             if (block == DUL_NOBLOCK)
             {
                 /* determine remaining time to wait */
-                timeToWait = timeout - (int) (time(NULL) - timerStart);
+                timeToWait = timeout - (time(NULL) - timerStart);
 
                 /* go ahead and see if within timeout seconds data will be received over the network. */
                 /* if not, return DUL_READTIMEOUT, if yes, stay in this function. */
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/libsrc/dulpriv.h dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/libsrc/dulpriv.h
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/libsrc/dulpriv.h	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/libsrc/dulpriv.h	2017-12-18 09:55:01.109524728 +0100
@@ -109,6 +109,6 @@
 	       PRV_ASSOCIATEPDU * pdu);
 OFCondition
 PRV_NextPDUType(PRIVATE_ASSOCIATIONKEY ** association,
-		DUL_BLOCKOPTIONS block, int timeout, unsigned char *type);
+		DUL_BLOCKOPTIONS block, OFTimeValue timeout, unsigned char *type);
 
 #endif
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/libsrc/dulstruc.h dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/libsrc/dulstruc.h
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/libsrc/dulstruc.h	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/libsrc/dulstruc.h	2017-12-18 09:55:31.125664019 +0100
@@ -95,7 +95,7 @@
     int applicationFunction;
     int networkState;
     int protocolState;
-    int timeout;
+    OFTimeValue timeout;
     unsigned long options;
     union {
   struct {
@@ -114,8 +114,8 @@
     DUL_ASSOC_STATE associationState;
     int protocolState;
     int networkState;
-    int timeout;
-    time_t timerStart;
+    OFTimeValue timeout;
+    OFTimeValue timerStart;
     unsigned long maxPDVRequestor;
     unsigned long maxPDVAcceptor;
     unsigned long maxPDV;
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/libsrc/scp.cc dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/libsrc/scp.cc
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/libsrc/scp.cc	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/libsrc/scp.cc	2017-12-18 10:03:49.343042230 +0100
@@ -315,11 +315,11 @@
   if (m_assoc != NULL)
     return DIMSE_ILLEGALASSOCIATION;
 
-  Uint32 timeout = m_cfg->getConnectionTimeout();
+  OFTimeValue timeout = m_cfg->getConnectionTimeout();
 
   // Listen to a socket for timeout seconds and wait for an association request
   OFCondition cond = ASC_receiveAssociation( network, &m_assoc, m_cfg->getMaxReceivePDULength(), NULL, NULL, OFFalse,
-                                             m_cfg->getConnectionBlockingMode(), OFstatic_cast(int, timeout) );
+                                             m_cfg->getConnectionBlockingMode(), OFstatic_cast(OFTimeValue, timeout) );
 
   // In case of a timeout in non-blocking mode, call notifier (and return
   // to main event loop later)
@@ -1439,7 +1439,7 @@
                                         T_DIMSE_Message *message,
                                         DcmDataset **statusDetail,
                                         DcmDataset **commandSet,
-                                        const Uint32 timeout)
+                                        const OFTimeValue timeout)
 {
   if (m_assoc == NULL)
     return DIMSE_ILLEGALASSOCIATION;
@@ -1693,21 +1693,21 @@
 
 // ----------------------------------------------------------------------------
 
-void DcmSCP::setDIMSETimeout(const Uint32 dimseTimeout)
+void DcmSCP::setDIMSETimeout(const OFTimeValue dimseTimeout)
 {
   m_cfg->setDIMSETimeout(dimseTimeout);
 }
 
 // ----------------------------------------------------------------------------
 
-void DcmSCP::setACSETimeout(const Uint32 acseTimeout)
+void DcmSCP::setACSETimeout(const OFTimeValue acseTimeout)
 {
   m_cfg->setACSETimeout(acseTimeout);
 }
 
 // ----------------------------------------------------------------------------
 
-void DcmSCP::setConnectionTimeout(const Uint32 timeout)
+void DcmSCP::setConnectionTimeout(const OFTimeValue timeout)
 {
   m_cfg->setConnectionTimeout(timeout);
 }
@@ -1793,21 +1793,21 @@
 
 // ----------------------------------------------------------------------------
 
-Uint32 DcmSCP::getDIMSETimeout() const
+OFTimeValue DcmSCP::getDIMSETimeout() const
 {
   return m_cfg->getDIMSETimeout();
 }
 
 // ----------------------------------------------------------------------------
 
-Uint32 DcmSCP::getConnectionTimeout() const
+OFTimeValue DcmSCP::getConnectionTimeout() const
 {
   return m_cfg->getConnectionTimeout();
 }
 
 // ----------------------------------------------------------------------------
 
-Uint32 DcmSCP::getACSETimeout() const
+OFTimeValue DcmSCP::getACSETimeout() const
 {
   return m_cfg->getACSETimeout();
 }
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/libsrc/scpcfg.cc dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/libsrc/scpcfg.cc
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/libsrc/scpcfg.cc	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/libsrc/scpcfg.cc	2017-12-18 09:55:26.046399455 +0100
@@ -155,21 +155,21 @@
 
 // ----------------------------------------------------------------------------
 
-void DcmSCPConfig::setDIMSETimeout(const Uint32 dimseTimeout)
+void DcmSCPConfig::setDIMSETimeout(const OFTimeValue dimseTimeout)
 {
   m_dimseTimeout = dimseTimeout;
 }
 
 // ----------------------------------------------------------------------------
 
-void DcmSCPConfig::setACSETimeout(const Uint32 acseTimeout)
+void DcmSCPConfig::setACSETimeout(const OFTimeValue acseTimeout)
 {
   m_acseTimeout = acseTimeout;
 }
 
 // ----------------------------------------------------------------------------
 
-void DcmSCPConfig::setConnectionTimeout(const Uint32 timeout)
+void DcmSCPConfig::setConnectionTimeout(const OFTimeValue timeout)
 {
   m_connectionTimeout = timeout;
 }
@@ -255,21 +255,21 @@
 
 // ----------------------------------------------------------------------------
 
-Uint32 DcmSCPConfig::getDIMSETimeout() const
+OFTimeValue DcmSCPConfig::getDIMSETimeout() const
 {
   return m_dimseTimeout;
 }
 
 // ----------------------------------------------------------------------------
 
-Uint32 DcmSCPConfig::getConnectionTimeout() const
+OFTimeValue DcmSCPConfig::getConnectionTimeout() const
 {
   return m_connectionTimeout;
 }
 
 // ----------------------------------------------------------------------------
 
-Uint32 DcmSCPConfig::getACSETimeout() const
+OFTimeValue DcmSCPConfig::getACSETimeout() const
 {
   return m_acseTimeout;
 }
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/libsrc/scu.cc dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/libsrc/scu.cc
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmnet/libsrc/scu.cc	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmnet/libsrc/scu.cc	2017-12-18 10:04:00.331360885 +0100
@@ -1995,7 +1995,7 @@
 // Receives N-EVENT-REPORT request
 OFCondition DcmSCU::handleEVENTREPORTRequest(DcmDataset *&reqDataset,
                                              Uint16 &eventTypeID,
-                                             const int timeout)
+                                             const OFTimeValue timeout)
 {
   // Do some basic validity checks
   if (!isConnected())
@@ -2194,7 +2194,7 @@
                                         T_DIMSE_Message *msg,
                                         DcmDataset **statusDetail,
                                         DcmDataset **commandSet,
-                                        const Uint32 timeout)
+                                        const OFTimeValue timeout)
 {
   if (!isConnected())
     return DIMSE_ILLEGALASSOCIATION;
@@ -2281,19 +2281,19 @@
 }
 
 
-void DcmSCU::setDIMSETimeout(const Uint32 dimseTimeout)
+void DcmSCU::setDIMSETimeout(const OFTimeValue dimseTimeout)
 {
   m_dimseTimeout = dimseTimeout;
 }
 
 
-void DcmSCU::setACSETimeout(const Uint32 acseTimeout)
+void DcmSCU::setACSETimeout(const OFTimeValue acseTimeout)
 {
   m_acseTimeout = acseTimeout;
 }
 
 
-void DcmSCU::setConnectionTimeout(const Sint32 connectionTimeout)
+void DcmSCU::setConnectionTimeout(const OFTimeValue connectionTimeout)
 {
   dcmConnectionTimeout.set(connectionTimeout);
 }
@@ -2386,19 +2386,19 @@
 }
 
 
-Uint32 DcmSCU::getDIMSETimeout() const
+OFTimeValue DcmSCU::getDIMSETimeout() const
 {
   return m_dimseTimeout;
 }
 
 
-Uint32 DcmSCU::getACSETimeout() const
+OFTimeValue DcmSCU::getACSETimeout() const
 {
   return m_acseTimeout;
 }
 
 
-Sint32 DcmSCU::getConnectionTimeout() const
+OFTimeValue DcmSCU::getConnectionTimeout() const
 {
   return dcmConnectionTimeout.get();
 }
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmpstat/apps/dcmprscp.cc dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmpstat/apps/dcmprscp.cc
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmpstat/apps/dcmprscp.cc	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmpstat/apps/dcmprscp.cc	2017-12-18 09:53:18.962180828 +0100
@@ -453,9 +453,9 @@
     }
 
 #ifdef HAVE_FORK
-    int timeout=1;
+    OFTimeValue timeout=1;
 #else
-    int timeout=1000;
+    OFTimeValue timeout=1000;
 #endif
 
     while (!finished)
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmpstat/apps/dcmprscu.cc dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmpstat/apps/dcmprscu.cc
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmpstat/apps/dcmprscu.cc	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmpstat/apps/dcmprscu.cc	2017-12-18 09:52:59.974832402 +0100
@@ -805,7 +805,7 @@
     deleteTerminateJobs         = dvi.getSpoolerAlwaysDeleteTerminateJobs();
     useTLS                      = dvi.getTargetUseTLS(opt_printer);
 
-    Sint32 timeout = dvi.getTargetTimeout(opt_printer);
+    OFTimeValue timeout = dvi.getTargetTimeout(opt_printer);
     if (timeout > 0) dcmConnectionTimeout.set(timeout);
 
 #ifdef WITH_OPENSSL
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmpstat/apps/dcmpsrcv.cc dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmpstat/apps/dcmpsrcv.cc
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmpstat/apps/dcmpsrcv.cc	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmpstat/apps/dcmpsrcv.cc	2017-12-18 09:53:17.501311076 +0100
@@ -1258,9 +1258,9 @@
       }
 
 #ifdef HAVE_FORK
-      int timeout=1;
+      OFTimeValue timeout=1;
 #else
-      int timeout=1000;
+      OFTimeValue timeout=1000;
 #endif
       while (!finished2)
       {
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmpstat/apps/dcmpssnd.cc dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmpstat/apps/dcmpssnd.cc
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmpstat/apps/dcmpssnd.cc	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmpstat/apps/dcmpssnd.cc	2017-12-18 09:53:20.578343976 +0100
@@ -420,7 +420,7 @@
     OFBool keepMessagePortOpen    = dvi.getMessagePortKeepOpen();
     OFBool useTLS = dvi.getTargetUseTLS(opt_target);
 
-    Sint32 timeout = dvi.getTargetTimeout(opt_target);
+    OFTimeValue timeout = dvi.getTargetTimeout(opt_target);
     if (timeout > 0) dcmConnectionTimeout.set(timeout);
 
 #ifdef WITH_OPENSSL
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmpstat/include/dcmtk/dcmpstat/dvpscf.h dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmpstat/include/dcmtk/dcmpstat/dvpscf.h
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmpstat/include/dcmtk/dcmpstat/dvpscf.h	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmpstat/include/dcmtk/dcmpstat/dvpscf.h	2017-12-18 09:58:27.733318076 +0100
@@ -125,7 +125,7 @@
    *    identifiers returned by getTargetID().
    *  @return entry if present and parsable in the config file, -1 otherwise.
    */
-  Sint32 getTargetTimeout(const char *targetID);
+  OFTimeValue getTargetTimeout(const char *targetID);
 
   /** returns the IMPLICITONLY entry for the communication partner with the given
    *  target ID from the configuration file.
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmpstat/include/dcmtk/dcmpstat/dvpspr.h dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmpstat/include/dcmtk/dcmpstat/dvpspr.h
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmpstat/include/dcmtk/dcmpstat/dvpspr.h	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmpstat/include/dcmtk/dcmpstat/dvpspr.h	2017-12-18 09:58:43.831551430 +0100
@@ -285,7 +285,7 @@
   T_DIMSE_BlockingMode blockMode;
 
   /// timeout for receive
-  int timeout;
+  OFTimeValue timeout;
 };
 
 #endif
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmpstat/include/dcmtk/dcmpstat/dvpsprt.h dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmpstat/include/dcmtk/dcmpstat/dvpsprt.h
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmpstat/include/dcmtk/dcmpstat/dvpsprt.h	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmpstat/include/dcmtk/dcmpstat/dvpsprt.h	2017-12-18 09:58:37.959500430 +0100
@@ -272,7 +272,7 @@
 
   /** timeout for receive
    */
-  int timeout;
+  OFTimeValue timeout;
 
   /** basic film session instance
    */
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmpstat/libsrc/dviface.cc dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmpstat/libsrc/dviface.cc
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmpstat/libsrc/dviface.cc	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmpstat/libsrc/dviface.cc	2017-12-18 10:41:48.797427883 +0100
@@ -1279,14 +1279,14 @@
     // date/time differences (i.e. over NFS)
 #ifdef HAVE_DECLARATION_STRUCT_UTIMBUF
     struct utimbuf utime_buf;
-    utime_buf.actime  = OFstatic_cast(time_t, referenceTime);
-    utime_buf.modtime = OFstatic_cast(time_t, referenceTime);
+    utime_buf.actime  = OFstatic_cast(OFTimeValue, referenceTime);
+    utime_buf.modtime = OFstatic_cast(OFTimeValue, referenceTime);
     if (0 != utime(databaseIndexFile.c_str(), &utime_buf))
 #else
-    // some old platforms use the prototype int utime(char *file, time_t timep[])
-    time_t utime_buf[2];
-    utime_buf[0]  = OFstatic_cast(time_t, referenceTime);
-    utime_buf[1] = OFstatic_cast(time_t, referenceTime);
+    // some old platforms use the prototype int utime(char *file, OFTimeValue timep[])
+    OFTimeValue utime_buf[2];
+    utime_buf[0]  = OFstatic_cast(OFTimeValue, referenceTime);
+    utime_buf[1] = OFstatic_cast(OFTimeValue, referenceTime);
     if (0 != utime(OFconst_cast(char *, databaseIndexFile.c_str()), utime_buf))
 #endif
     {
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmpstat/libsrc/dvpscf.cc dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmpstat/libsrc/dvpscf.cc
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmpstat/libsrc/dvpscf.cc	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmpstat/libsrc/dvpscf.cc	2017-12-18 09:53:22.012734297 +0100
@@ -406,7 +406,7 @@
   return result;
 }
 
-Sint32 DVConfiguration::getTargetTimeout(const char *targetID)
+OFTimeValue DVConfiguration::getTargetTimeout(const char *targetID)
 {
   const char *c = getConfigEntry(L2_COMMUNICATION, targetID, L0_TIMEOUT);
   signed long result = -1; // default is -1
@@ -414,7 +414,7 @@
   {
     if (1 != sscanf(c, "%ld", &result)) result=0;
   }
-  return (Sint32) result;
+  return (OFTimeValue) result;
 }
 
 OFBool DVConfiguration::getTargetImplicitOnly(const char *targetID)
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmqrdb/apps/dcmqrscp.cc dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmqrdb/apps/dcmqrscp.cc
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmqrdb/apps/dcmqrscp.cc	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmqrdb/apps/dcmqrscp.cc	2017-12-18 09:57:03.508328055 +0100
@@ -475,21 +475,21 @@
       {
         OFCmdSignedInt opt_timeout = 0;
         app.checkValue(cmd.getValueAndCheckMin(opt_timeout, 1));
-        dcmConnectionTimeout.set((Sint32) opt_timeout);
+        dcmConnectionTimeout.set((OFTimeValue) opt_timeout);
       }
 
       if (cmd.findOption("--acse-timeout"))
       {
         OFCmdSignedInt opt_timeout = 0;
         app.checkValue(cmd.getValueAndCheckMin(opt_timeout, 1));
-        options.acse_timeout_ = OFstatic_cast(int, opt_timeout);
+        options.acse_timeout_ = OFstatic_cast(OFTimeValue, opt_timeout);
       }
 
       if (cmd.findOption("--dimse-timeout"))
       {
         OFCmdSignedInt opt_timeout = 0;
         app.checkValue(cmd.getValueAndCheckMin(opt_timeout, 1));
-        options.dimse_timeout_ = OFstatic_cast(int, opt_timeout);
+        options.dimse_timeout_ = OFstatic_cast(OFTimeValue, opt_timeout);
         options.blockMode_ = DIMSE_NONBLOCKING;
       }
 
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmqrdb/apps/dcmqrti.cc dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmqrdb/apps/dcmqrti.cc
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmqrdb/apps/dcmqrti.cc	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmqrdb/apps/dcmqrti.cc	2017-12-18 09:56:41.066963338 +0100
@@ -85,7 +85,7 @@
   int remoteDBTitlesCount = 0;
   const char *configFileName = DEFAULT_CONFIGURATION_DIR "dcmqrscp.cfg";
   E_TransferSyntax networkTransferSyntax = EXS_Unknown;
-  int opt_acse_timeout = 30;
+  OFTimeValue opt_acse_timeout = 30;
 
   const char *currentPeer = NULL, **vendorHosts, **aeTitleList;
   OFBool noCommandLineValueForMaxReceivePDULength = OFTrue;
@@ -197,21 +197,21 @@
     {
       OFCmdSignedInt opt_timeout = 0;
       app.checkValue(cmd.getValueAndCheckMin(opt_timeout, 1));
-      dcmConnectionTimeout.set(OFstatic_cast(Sint32, opt_timeout));
+      dcmConnectionTimeout.set(OFstatic_cast(OFTimeValue, opt_timeout));
     }
 
     if (cmd.findOption("--acse-timeout"))
     {
       OFCmdSignedInt opt_timeout = 0;
       app.checkValue(cmd.getValueAndCheckMin(opt_timeout, 1));
-      opt_acse_timeout = OFstatic_cast(int, opt_timeout);
+      opt_acse_timeout = OFstatic_cast(OFTimeValue, opt_timeout);
     }
 
     if (cmd.findOption("--dimse-timeout"))
     {
       OFCmdSignedInt opt_timeout = 0;
       app.checkValue(cmd.getValueAndCheckMin(opt_timeout, 1));
-      conf.setBlockMode(DIMSE_NONBLOCKING, OFstatic_cast(int, opt_timeout));
+      conf.setBlockMode(DIMSE_NONBLOCKING, OFstatic_cast(OFTimeValue, opt_timeout));
     }
 
     if (cmd.findOption("--disable-new-vr"))
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmqrdb/include/dcmtk/dcmqrdb/dcmqropt.h dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmqrdb/include/dcmtk/dcmqrdb/dcmqropt.h
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmqrdb/include/dcmtk/dcmqrdb/dcmqropt.h	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmqrdb/include/dcmtk/dcmqrdb/dcmqropt.h	2017-12-18 10:01:46.239149800 +0100
@@ -155,10 +155,10 @@
   T_DIMSE_BlockingMode blockMode_;
 
   /// timeout for DIMSE operations
-  int dimse_timeout_;
+  OFTimeValue dimse_timeout_;
 
   /// timeout for ACSE operations
-  int acse_timeout_;
+  OFTimeValue acse_timeout_;
 
   // association configuration file name
   OFString associationConfigFile;
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmqrdb/include/dcmtk/dcmqrdb/dcmqrtis.h dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmqrdb/include/dcmtk/dcmqrdb/dcmqrtis.h
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmqrdb/include/dcmtk/dcmqrdb/dcmqrtis.h	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmqrdb/include/dcmtk/dcmqrdb/dcmqrtis.h	2017-12-18 10:01:57.787261360 +0100
@@ -63,7 +63,7 @@
     TI_ImageEntry *images[TI_MAXIMAGES];  /* array of image pointers */
     int     imageCount;
 
-    time_t lastQueryTime; /* time we last queried db */
+    OFTimeValue lastQueryTime; /* time we last queried db */
 };
 
 struct DCMTK_DCMQRDB_EXPORT TI_StudyEntry
@@ -74,7 +74,7 @@
     DIC_LO  patientID;
     TI_SeriesEntry  *series[TI_MAXSERIES];  /* array of series pointers */
     int     seriesCount;
-    time_t lastQueryTime; /* time we last queried db */
+    OFTimeValue lastQueryTime; /* time we last queried db */
 };
 
 
@@ -95,7 +95,7 @@
     int currentSeries;  /* index of current series in current study */
     int currentImage; /* index of current image in current study */
 
-    time_t lastQueryTime; /* time we last queried db */
+    OFTimeValue lastQueryTime; /* time we last queried db */
 
     OFBool isRemoteDB;  /* true if DB is remote */
 };
@@ -196,7 +196,7 @@
      *  @param blockMode blocking mode for DIMSE operations
      *  @param timeout timeout for DIMSE operations
      */
-    void setBlockMode(T_DIMSE_BlockingMode blockMode, int timeout)
+    void setBlockMode(T_DIMSE_BlockingMode blockMode, OFTimeValue timeout)
     {
       blockMode_ = blockMode;
       dimse_timeout_ = timeout;
@@ -236,7 +236,7 @@
     OFBool TI_buildRemoteStudies(TI_DBEntry *db);
     OFBool TI_buildRemoteSeries(TI_DBEntry *db, TI_StudyEntry *study);
     OFBool TI_dbReadable(const char *dbTitle);
-    time_t TI_dbModifyTime(const char *dbTitle);
+    OFTimeValue TI_dbModifyTime(const char *dbTitle);
     OFCondition addPresentationContexts(T_ASC_Parameters *params);
     void selectDestinationCharacterSet(OFString& destinationCharacterSet);
 
@@ -288,7 +288,7 @@
     T_DIMSE_BlockingMode blockMode_;
 
     /// timeout for DIMSE operations
-    int dimse_timeout_;
+    OFTimeValue dimse_timeout_;
 
 };
 
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmqrdb/libsrc/dcmqrptb.cc dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmqrdb/libsrc/dcmqrptb.cc
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmqrdb/libsrc/dcmqrptb.cc	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmqrdb/libsrc/dcmqrptb.cc	2017-12-18 09:58:09.107054138 +0100
@@ -41,7 +41,7 @@
     const char *callingAETitle,
     const char *calledAETitle,
     int processId,
-    time_t startTime,
+    OFTimeValue startTime,
     OFBool hasStorageAbility);
 
   /// destructor
@@ -74,7 +74,7 @@
     int      processId_;
 
     /// time the child process was started
-    time_t   startTime_;
+    OFTimeValue   startTime_;
 
     /// true if the child process is allowed to store
     OFBool   hasStorageAbility_;
@@ -86,7 +86,7 @@
       const char *callingAETitle,
       const char *calledAETitle,
       int processId,
-      time_t startTime,
+      OFTimeValue startTime,
       OFBool hasStorageAbility)
 : peerName_()
 , callingAETitle_()
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmqrdb/libsrc/dcmqrsrv.cc dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmqrdb/libsrc/dcmqrsrv.cc
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmqrdb/libsrc/dcmqrsrv.cc	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmqrdb/libsrc/dcmqrsrv.cc	2017-12-18 09:57:18.503392064 +0100
@@ -964,7 +964,7 @@
 #endif
     T_ASC_Association  *assoc;
     char                buf[BUFSIZ];
-    int timeout;
+    OFTimeValue timeout;
     OFBool go_cleanup = OFFalse;
 
     if (options_.singleProcess_) timeout = 1000;
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmqrdb/libsrc/dcmqrtis.cc dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmqrdb/libsrc/dcmqrtis.cc
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmqrdb/libsrc/dcmqrtis.cc	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmqrdb/libsrc/dcmqrtis.cc	2017-12-18 09:57:08.706208984 +0100
@@ -1738,7 +1738,7 @@
     return (access(path, R_OK) == 0);
 }
 
-time_t DcmQueryRetrieveTelnetInitiator::TI_dbModifyTime(const char *dbTitle)
+OFTimeValue DcmQueryRetrieveTelnetInitiator::TI_dbModifyTime(const char *dbTitle)
 {
     char path[MAXPATHLEN+1];
     struct stat s;
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmtls/include/dcmtk/dcmtls/tlstrans.h dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmtls/include/dcmtk/dcmtls/tlstrans.h
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmtls/include/dcmtk/dcmtls/tlstrans.h	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmtls/include/dcmtk/dcmtls/tlstrans.h	2017-12-18 09:58:23.518984616 +0100
@@ -118,7 +118,7 @@
    *     If this parameter is 0, the function does not block.
    *  @returns OFTrue if data is available, OFFalse otherwise.
    */
-  virtual OFBool networkDataAvailable(int timeout);
+  virtual OFBool networkDataAvailable(OFTimeValue timeout);
 
   /** returns OFTrue if this connection is a transparent TCP connection,
    *  OFFalse if the connection is a secure connection.
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmtls/libsrc/tlstrans.cc dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmtls/libsrc/tlstrans.cc
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmtls/libsrc/tlstrans.cc	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmtls/libsrc/tlstrans.cc	2017-12-18 09:52:46.808387491 +0100
@@ -248,7 +248,7 @@
   return result;
 }
 
-OFBool DcmTLSConnection::networkDataAvailable(int timeout)
+OFBool DcmTLSConnection::networkDataAvailable(OFTimeValue timeout)
 {
   /* this is an approximation since SSL_pending does not support
    * waiting with a timeout. We first check SSL_pending and then
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmwlm/apps/wlcefs.cc dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmwlm/apps/wlcefs.cc
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmwlm/apps/wlcefs.cc	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmwlm/apps/wlcefs.cc	2017-12-18 09:53:25.076679343 +0100
@@ -279,14 +279,14 @@
     {
       OFCmdSignedInt opt_timeout = 0;
       app->checkValue(cmd->getValueAndCheckMin(opt_timeout, 1));
-      opt_acse_timeout = OFstatic_cast(int, opt_timeout);
+      opt_acse_timeout = OFstatic_cast(OFTimeValue, opt_timeout);
     }
 
     if (cmd->findOption("--dimse-timeout"))
     {
       OFCmdSignedInt opt_timeout = 0;
       app->checkValue(cmd->getValueAndCheckMin(opt_timeout, 1));
-      opt_dimse_timeout = OFstatic_cast(int, opt_timeout);
+      opt_dimse_timeout = OFstatic_cast(OFTimeValue, opt_timeout);
       opt_blockMode = DIMSE_NONBLOCKING;
     }
 
diff -Nur dcmtk-for-dcmjp2k-3.6.2-unix/dcmwlm/apps/wlcefs.h dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmwlm/apps/wlcefs.h
--- dcmtk-for-dcmjp2k-3.6.2-unix/dcmwlm/apps/wlcefs.h	2017-07-14 17:41:11.000000000 +0200
+++ dcmtk-for-dcmjp2k-3.6.2-unix.patched/dcmwlm/apps/wlcefs.h	2017-12-18 09:53:28.928494410 +0100
@@ -71,9 +71,9 @@
     /// blocking mode for DIMSE operations
     T_DIMSE_BlockingMode opt_blockMode;
     /// timeout for DIMSE operations
-    int opt_dimse_timeout;
+    OFTimeValue opt_dimse_timeout;
     /// timeout for ACSE operations
-    int opt_acse_timeout;
+    OFTimeValue opt_acse_timeout;
     /// instance of console application class (for handling command line arguments)
     OFConsoleApplication *app;
     /// instance of command line class (for handling command line arguments)
